#include "fsgui3dviewcontrol.h"
#include "fsgui3dviewcontroldialog.h"
#include <fssimplewindow.h>



FsGui3DViewControlDialog::FsGui3DViewControlDialog()
{
	viewControl=NULL;
	lastView.pos=YsOrigin();
	lastView.att=YsZeroAtt();
}

void FsGui3DViewControlDialog::Make(class FsGui3DViewControl *viewControl)
{
	this->viewControl=viewControl;
	viewControl->viewControlDialog=this;

	YsArray <YsArray <FsGuiDialogItem *> > dlgItemMatrix;

	dlgItemMatrix.Set(6,NULL);
	dlgItemMatrix[0].Set(4,NULL);
	dlgItemMatrix[1].Set(4,NULL);
	dlgItemMatrix[2].Set(4,NULL);
	dlgItemMatrix[3].Set(4,NULL);
	dlgItemMatrix[4].Set(4,NULL);
	dlgItemMatrix[5].Set(4,NULL);



	rollLeftBtn=AddTextButton(0,FSKEY_NULL,FSGUI_PUSHBUTTON,"<",YSTRUE);
	noseDownBtn=AddTextButton(0,FSKEY_NULL,FSGUI_PUSHBUTTON,"^",YSFALSE);
	rollRightBtn=AddTextButton(0,FSKEY_NULL,FSGUI_PUSHBUTTON,">",YSFALSE);
	frontViewBtn=AddTextButton(0,FSKEY_NULL,FSGUI_PUSHBUTTON,"Front",YSFALSE);

	yawLeftBtn=AddTextButton(0,FSKEY_NULL,FSGUI_PUSHBUTTON,"<",YSTRUE);
	zeroAttBtn=AddTextButton(0,FSKEY_NULL,FSGUI_PUSHBUTTON,"O",YSFALSE);
	yawRightBtn=AddTextButton(0,FSKEY_NULL,FSGUI_PUSHBUTTON,">",YSFALSE);
	rearViewBtn=AddTextButton(0,FSKEY_NULL,FSGUI_PUSHBUTTON,"Rear",YSFALSE);

	noseUpBtn=AddTextButton(0,FSKEY_NULL,FSGUI_PUSHBUTTON,"v",YSTRUE);
	topViewBtn=AddTextButton(0,FSKEY_NULL,FSGUI_PUSHBUTTON,"Top",YSFALSE);



	scrollUpBtn=AddTextButton(0,FSKEY_NULL,FSGUI_PUSHBUTTON,"^",YSTRUE);
	bottomViewBtn=AddTextButton(0,FSKEY_NULL,FSGUI_PUSHBUTTON,"Bottom",YSFALSE);

	scrollLeftBtn=AddTextButton(0,FSKEY_NULL,FSGUI_PUSHBUTTON,"<",YSTRUE);
	centerBtn=AddTextButton(0,FSKEY_NULL,FSGUI_PUSHBUTTON,"O",YSFALSE);
	scrollRightBtn=AddTextButton(0,FSKEY_NULL,FSGUI_PUSHBUTTON,">",YSFALSE);
	leftViewBtn=AddTextButton(0,FSKEY_NULL,FSGUI_PUSHBUTTON,"Left",YSFALSE);

	scrollDownBtn=AddTextButton(0,FSKEY_NULL,FSGUI_PUSHBUTTON,"v",YSTRUE);
	rightViewBtn=AddTextButton(0,FSKEY_NULL,FSGUI_PUSHBUTTON,"Right",YSFALSE);


	dlgItemMatrix[0][0]=rollLeftBtn;
	dlgItemMatrix[0][1]=noseDownBtn;
	dlgItemMatrix[0][2]=rollRightBtn;
	dlgItemMatrix[0][3]=frontViewBtn;

	dlgItemMatrix[1][0]=yawLeftBtn;
	dlgItemMatrix[1][1]=zeroAttBtn;
	dlgItemMatrix[1][2]=yawRightBtn;
	dlgItemMatrix[1][3]=rearViewBtn;

	dlgItemMatrix[2][0]=NULL;
	dlgItemMatrix[2][1]=noseUpBtn;
	dlgItemMatrix[2][2]=NULL;
	dlgItemMatrix[2][3]=topViewBtn;

	dlgItemMatrix[3][0]=NULL;
	dlgItemMatrix[3][1]=scrollUpBtn;
	dlgItemMatrix[3][2]=NULL;
	dlgItemMatrix[3][3]=bottomViewBtn;

	dlgItemMatrix[4][0]=scrollLeftBtn;
	dlgItemMatrix[4][1]=centerBtn;
	dlgItemMatrix[4][2]=scrollRightBtn;
	dlgItemMatrix[4][3]=leftViewBtn;

	dlgItemMatrix[5][0]=NULL;
	dlgItemMatrix[5][1]=scrollDownBtn;
	dlgItemMatrix[5][2]=NULL;
	dlgItemMatrix[5][3]=rightViewBtn;

	AlignLeftMiddle(dlgItemMatrix);



	lockOrientationBtn=AddTextButton(0,FSKEY_NULL,FSGUI_CHECKBOX,"Lock Rotation",YSTRUE);
	lockTranslationBtn=AddTextButton(0,FSKEY_NULL,FSGUI_CHECKBOX,"Lock Scroll",YSTRUE);



	zoomBtn=AddTextButton(0,FSKEY_NULL,FSGUI_PUSHBUTTON,"Zoom",YSTRUE);
	moozBtn=AddTextButton(0,FSKEY_NULL,FSGUI_PUSHBUTTON,"Mooz",YSFALSE);
	orbitBtn=AddTextButton(0,FSKEY_NULL,FSGUI_PUSHBUTTON,"Orbit",YSTRUE);
	orthoPersBtn=AddTextButton(0,FSKEY_NULL,FSGUI_PUSHBUTTON,"Ortho/Pers",YSFALSE);



	lookAtCoordTxt=AddTextBox(0,FSKEY_NULL,"",16,YSTRUE);
	lookAtBtn=AddTextButton(0,FSKEY_NULL,FSGUI_PUSHBUTTON,"Look At",YSTRUE);
	lastViewBtn=AddTextButton(0,FSKEY_NULL,FSGUI_PUSHBUTTON,"Last View",YSFALSE);
	lookAtCutBufBtn=AddTextButton(0,FSKEY_NULL,FSGUI_PUSHBUTTON,"Look At Cut-Buffer",YSTRUE);



	saveViewBtn=AddTextButton(0,FSKEY_NULL,FSGUI_PUSHBUTTON,"Save View",YSTRUE);
	loadViewBtn=AddTextButton(0,FSKEY_NULL,FSGUI_PUSHBUTTON,"Load View",YSFALSE);

	SetArrangeType(FSDIALOG_ARRANGE_TOP_RIGHT);
	Fit();
	SetBackgroundAlpha(0.5);
}



void FsGui3DViewControlDialog::OnButtonClick(FsGuiButton *btn)
{
	if(NULL==viewControl)
	{
		return;
	}

	if(NULL!=btn && btn==rollLeftBtn)
	{
		YsAtt3 att=viewControl->GetViewAttitude();
		att.AddB(YsPi/36.0);
		viewControl->SetViewAttitude(att);
		viewControl->SetNeedRedraw(YSTRUE);
	}
	if(NULL!=btn && btn==noseDownBtn)
	{
		YsAtt3 att=viewControl->GetViewAttitude();
		att.NoseUp(-YsPi/36.0);
		viewControl->SetViewAttitude(att);
		viewControl->SetNeedRedraw(YSTRUE);
	}
	if(NULL!=btn && btn==rollRightBtn)
	{
		YsAtt3 att=viewControl->GetViewAttitude();
		att.AddB(-YsPi/36.0);
		viewControl->SetViewAttitude(att);
		viewControl->SetNeedRedraw(YSTRUE);
	}
	if(NULL!=btn && btn==yawLeftBtn)
	{
		YsAtt3 att=viewControl->GetViewAttitude();
		att.YawLeft(-YsPi/36.0);
		viewControl->SetViewAttitude(att);
		viewControl->SetNeedRedraw(YSTRUE);
	}
	if(NULL!=btn && btn==zeroAttBtn)
	{
		viewControl->SetViewAttitude(YsZeroAtt());
		viewControl->SetNeedRedraw(YSTRUE);
	}
	if(NULL!=btn && btn==yawRightBtn)
	{
		YsAtt3 att=viewControl->GetViewAttitude();
		att.YawLeft(YsPi/36.0);
		viewControl->SetViewAttitude(att);
		viewControl->SetNeedRedraw(YSTRUE);
	}
	if(NULL!=btn && btn==noseUpBtn)
	{
		YsAtt3 att=viewControl->GetViewAttitude();
		att.NoseUp(YsPi/36.0);
		viewControl->SetViewAttitude(att);
		viewControl->SetNeedRedraw(YSTRUE);
	}

	if(NULL!=btn && btn==scrollUpBtn)
	{
		Translate(0.0,-0.05);
	}
	if(NULL!=btn && btn==scrollLeftBtn)
	{
		Translate(0.05,0.0);
	}
	if(NULL!=btn && btn==centerBtn)
	{
		YsVec3 min,max;
		viewControl->GetTargetBoundingBox(min,max);
		viewControl->SetViewTarget((min+max)/2.0);
	}
	if(NULL!=btn && btn==scrollRightBtn)
	{
		Translate(-0.05,0.0);
	}
	if(NULL!=btn && btn==scrollDownBtn)
	{
		Translate(0.0,0.05);
	}

	if(NULL!=btn && btn==lockOrientationBtn)
	{
		SetOrientationLock(lockOrientationBtn->GetCheck());
	}
	if(NULL!=btn && btn==lockTranslationBtn)
	{
		SetTranslationLock(lockTranslationBtn->GetCheck());
	}

	if(NULL!=btn && btn==frontViewBtn)
	{
	}
	if(NULL!=btn && btn==rearViewBtn)
	{
	}
	if(NULL!=btn && btn==topViewBtn)
	{
	}
	if(NULL!=btn && btn==bottomViewBtn)
	{
	}
	if(NULL!=btn && btn==leftViewBtn)
	{
	}
	if(NULL!=btn && btn==rightViewBtn)
	{
	}

	if(NULL!=btn && btn==zoomBtn)
	{
	}
	if(NULL!=btn && btn==moozBtn)
	{
	}
	if(NULL!=btn && btn==orthoPersBtn)
	{
	}
	if(NULL!=btn && btn==orbitBtn)
	{
	}

	//FsGuiTextBox *lookAtCoordTxt

	if(NULL!=btn && btn==lookAtBtn)
	{
		SaveLastView();
		YsString str;
		lookAtCoordTxt->GetText(str);
		for(YSSIZE_T idx=0; idx<str.Strlen(); ++idx)
		{
			if('('==str[idx] || ')'==str[idx] || ','==str[idx])
			{
				str.Set(idx,' ');
			}
		}
		YsArray <YsString,4> xyz;
		str.Arguments(xyz);

		YsVec3 pos=viewControl->GetViewTarget();
		if(1<=xyz.GetN())
		{
			pos.SetX(atof(xyz[0]));
		}
		if(2<=xyz.GetN())
		{
			pos.SetY(atof(xyz[1]));
		}
		if(3<=xyz.GetN())
		{
			pos.SetZ(atof(xyz[2]));
		}

		viewControl->SetViewTarget(pos);
	}
	if(NULL!=btn && btn==lastViewBtn)
	{
		RecallLastView();
	}
	if(NULL!=btn && btn==lookAtCutBufBtn)
	{
	}

	if(NULL!=btn && btn==saveViewBtn)
	{
	}
	if(NULL!=btn && btn==loadViewBtn)
	{
	}
}

void FsGui3DViewControlDialog::Translate(double dx,double dy)
{
	if(NULL!=viewControl && YSTRUE!=lockTranslationBtn->GetCheck())
	{
		double vx,vy;
		if(viewControl->GetPerspective()!=YSTRUE)
		{
			double x1,y1,x2,y2;
			viewControl->GetOrthogonalRangeWithZoom(x1,y1,x2,y2);
			const double sx=fabs(x1-x2);
			const double sy=fabs(y1-y2);

			vx=dx*sx;
			vy=dy*sy;
		}
		else
		{
			const double tanfov=tan(viewControl->GetFOVY());
			const double viewDist=viewControl->GetViewDistance();
			vx=2.0*(dx*viewDist*tanfov/viewControl->GetZoom());
			vy=2.0*(dy*viewDist*tanfov/viewControl->GetZoom());
		}

		YsVec3 v(vx,vy,0.0);
		viewControl->GetViewMatrix().MulInverse(v,v,0.0);
		v+=viewControl->GetViewTarget();

		viewControl->SetViewTarget(v);
	}
}

void FsGui3DViewControlDialog::SetOrientationLock(YSBOOL lock)
{
	lockOrientationBtn->SetCheck(lock);
	if(NULL!=viewControl)
	{
		viewControl->orientationLock=lock;  // SetOrientationLock will call this function back and make an infinite recursion.
	}

	rollLeftBtn->SetEnabled(YsReverseBool(lock));
	noseDownBtn->SetEnabled(YsReverseBool(lock));
	rollRightBtn->SetEnabled(YsReverseBool(lock));
	yawLeftBtn->SetEnabled(YsReverseBool(lock));
	zeroAttBtn->SetEnabled(YsReverseBool(lock));
	yawRightBtn->SetEnabled(YsReverseBool(lock));
	noseUpBtn->SetEnabled(YsReverseBool(lock));

	frontViewBtn->SetEnabled(YsReverseBool(lock));
	rearViewBtn->SetEnabled(YsReverseBool(lock));
	topViewBtn->SetEnabled(YsReverseBool(lock));
	bottomViewBtn->SetEnabled(YsReverseBool(lock));
	leftViewBtn->SetEnabled(YsReverseBool(lock));
	rightViewBtn->SetEnabled(YsReverseBool(lock));
}

void FsGui3DViewControlDialog::SetTranslationLock(YSBOOL lock)
{
	lockTranslationBtn->SetCheck(lock);
	if(NULL!=viewControl)
	{
		viewControl->translationLock=lock;
	}

	scrollUpBtn->SetEnabled(YsReverseBool(lock));
	scrollLeftBtn->SetEnabled(YsReverseBool(lock));
	centerBtn->SetEnabled(YsReverseBool(lock));
	scrollRightBtn->SetEnabled(YsReverseBool(lock));
	scrollDownBtn->SetEnabled(YsReverseBool(lock));
}

void FsGui3DViewControlDialog::UpdateViewTarget(const YsVec3 &pos)
{
	YsString str;
	str.Printf("%.3lf, %.3lf, %.3lf",pos.x(),pos.y(),pos.z());
	lookAtCoordTxt->SetText(str);
}

void FsGui3DViewControlDialog::SaveLastView(void)
{
	if(NULL!=viewControl && lastView.pos!=viewControl->GetViewTarget())
	{
		lastView.pos=viewControl->GetViewTarget();
		lastView.att=viewControl->GetViewAttitude();
	}
}

FsGui3DViewControlDialog::PosAttPair FsGui3DViewControlDialog::RecallLastView(void)
{
	if(NULL!=viewControl)
	{
		viewControl->SetViewTarget(lastView.pos);
		viewControl->SetViewAttitude(lastView.att);
	}
	return lastView;
}

