#ifndef FSGUI_DVIEWCONTROLDIALOG_IS_INCLUDED
#define FSGUI_DVIEWCONTROLDIALOG_IS_INCLUDED
/* { */

#include "fsgui3dviewcontrol.h"
#include <fsgui.h>

class FsGui3DViewControlDialog : public FsGuiDialog
{
private:
	FsGuiButton *rollLeftBtn,*noseDownBtn,*rollRightBtn;
	FsGuiButton *yawLeftBtn,*zeroAttBtn,*yawRightBtn;
	FsGuiButton *noseUpBtn;

	FsGuiButton *scrollUpBtn;
	FsGuiButton *scrollLeftBtn,*centerBtn,*scrollRightBtn;
	FsGuiButton *scrollDownBtn;

	FsGuiButton *lockOrientationBtn;
	FsGuiButton *lockTranslationBtn;

	FsGuiButton *frontViewBtn,*rearViewBtn;
	FsGuiButton *topViewBtn,*bottomViewBtn;
	FsGuiButton *leftViewBtn,*rightViewBtn;

	FsGuiButton *zoomBtn,*moozBtn;
	FsGuiButton *orthoPersBtn;
	FsGuiButton *orbitBtn;

	FsGuiTextBox *lookAtCoordTxt;
	FsGuiButton *lookAtBtn,*lastViewBtn;
	FsGuiButton *lastLookAtBtn;
	FsGuiButton *lookAtCutBufBtn;

	FsGuiButton *saveViewBtn,*loadViewBtn;

	class FsGui3DViewControl *viewControl;
	friend class FsGui3DViewControl;


	class PosAttPair
	{
	public:
		YsVec3 pos;
		YsAtt3 att;
	};
	PosAttPair lastView;

public:
	/*! Default constructor */
	FsGui3DViewControlDialog();

	/*! This function makes the dialog from a view controller. */
	void Make(class FsGui3DViewControl *viewControl);

	/*! Call back function for button click. */
	virtual void OnButtonClick(FsGuiButton *btn);

	/*! This function sets lock-orientation status. */
	void SetOrientationLock(YSBOOL lock);

	/*! This function sets lock-translation status. */
	void SetTranslationLock(YSBOOL lock);

private:
	void Translate(double vx,double vy);
	void UpdateViewTarget(const YsVec3 &pos);
	void SaveLastView(void);
	PosAttPair RecallLastView(void);
};

/* } */
#endif
