#include <fssimplewindow.h>

// Comment out FSGUI3D_USE_SYSTEM_FONT to remove depencency on YsSystemFont library.
#define FSGUI3D_USE_SYSTEM_FONT


#ifdef FSGUI3D_USE_SYSTEM_FONT
#include <ysfontrenderer.h>
#endif

#include "fsgui3dapp.h"

// Modify this program if the initial window location needs to be changed.

int main(void)
{
	FsOpenWindow(32,32,1024,640,1);


#ifdef FSGUI3D_USE_SYSTEM_FONT
	YsSystemFontRenderer *sysFont=new YsSystemFontRenderer;
	FsGuiObject::defUnicodeRenderer=sysFont;
#endif

	FsGuiObject::defUnicodeRenderer->RequestDefaultFontWithPixelHeight(16);
	FsGuiObject::defAsciiRenderer->RequestDefaultFontWithPixelHeight(16);

	FsGui3DAppInitialize();

	while(YSTRUE!=FsGui3dAppMustTerminate())
	{
		FsPollDevice();
		FsGui3DAppIntervalCallBack();
		FsSleep(FsGui3dAppSleepIntervalInMS());
	}

	FsGui3dAppCleanUp();

#ifdef FSGUI3D_USE_SYSTEM_FONT
	delete sysFont;
#endif

	FsSleep(50); // Windows apparently has a problem terminating within certain time after last rendering.  Wait 50 ms.

	exit(0); // This typically is quicker, otherwise destructors occasinally takes long time to finish.
	return 0;
}

#ifdef _WIN32
// Infamouse WinMain function.  This function will be used when SUBSYSTEM is set to WINDOWS.
#include <windows.h>
int PASCAL WinMain(HINSTANCE inst,HINSTANCE,LPSTR param,int)
{
	return main();
}
#endif
