#import <Cocoa/Cocoa.h>
// #import AppKit?

static int YsSeparatePathFile(char *pth,char *fil,const char *org)
{
	char tmp[256],*seekPtr,*cutPtr;

	strcpy(tmp,org);
	cutPtr=tmp;

	/* Ysip Drive Name */
	if(tmp[1]==':')
	{
		cutPtr+=2;
	}

	/* scan until nul Stopper */
	for(seekPtr=cutPtr; *seekPtr!=0; seekPtr++)
	{
		if(*seekPtr=='\\' || *seekPtr=='/' || *seekPtr==':')
		{
			cutPtr=seekPtr+1;
		}
	}

	/* cutPtr points *tmp  or after ':' or after last '\\' */
	strcpy(fil,cutPtr);

	*cutPtr = 0;
	strcpy(pth,tmp);
	return 1;
}

int FsOpenFileDialogC(char fn[],const char title[],const char defFn[],const char defExt[])
{
 	NSAutoreleasePool *pool=[[NSAutoreleasePool alloc] init];


	NSOpenPanel *openPanel=[NSOpenPanel openPanel];
	NSArray *extArray=NULL;
	NSString *extStr=NULL;


	[openPanel setAllowsMultipleSelection:NO];
	[openPanel setCanChooseDirectories:NO];

	[openPanel setTitle:[NSString stringWithUTF8String:title]];
	[openPanel setTreatsFilePackagesAsDirectories:YES];

	if(defExt!=NULL)
	{
		if(defExt[0]=='*')
		{
			defExt++;
		}
		if(defExt[0]=='.')
		{
			defExt++;
		}

		extStr=[[NSString alloc] initWithUTF8String:defExt];
		extArray=[NSArray arrayWithObjects:extStr,nil];
		[openPanel setAllowedFileTypes:extArray];
		[openPanel setAllowsOtherFileTypes:NO];
	}

	char iniPath[260],iniFile[260];
	if(defFn!=NULL && defFn[0]!=0)
	{
		YsSeparatePathFile(iniPath,iniFile,defFn);
		if(strcmp(iniPath,"./")==0)
		{
			getcwd(iniPath,259);
		}
	}
	else
	{
		getcwd(iniPath,259);
		iniFile[0]=0;
	}

	[openPanel setDirectory:[NSString stringWithUTF8String:iniPath]];
	// setDirectory will be replaced with setDirectoryURL
	if(iniFile[0]!=0)
	{
	  // [openPanel setNameFieldStringValue:[NSString stringWithUTF8String:iniFile]];
	}

	if(NSFileHandlingPanelOKButton==[openPanel runModal])
	{
		strcpy(fn,[[[openPanel URL] path] UTF8String]);
		// Tried: absoluteString
		printf("[Selected]\n");
		printf("%s\n",fn);

		[pool release];

		[[NSApp mainWindow] makeKeyAndOrderFront:nil];

		return 1;
	}

	[[NSApp mainWindow] makeKeyAndOrderFront:nil];
	fn[0]=0;
	[pool release];
	return 0;
}




int FsSaveFileDialogC(char fn[],const char title[],const char defFn[],const char defExt[])
{
 	NSAutoreleasePool *pool=[[NSAutoreleasePool alloc] init];


	NSSavePanel *savePanel=[NSSavePanel savePanel];
	NSArray *extArray=NULL;
	NSString *extStr=NULL;


	[savePanel setTitle:[NSString stringWithUTF8String:title]];
	[savePanel setTreatsFilePackagesAsDirectories:YES];
	[savePanel setCanCreateDirectories:YES];

	if(defExt!=NULL)
	{
		if(defExt[0]=='*')
		{
			defExt++;
		}
		if(defExt[0]=='.')
		{
			defExt++;
		}

		extStr=[[NSString alloc] initWithUTF8String:defExt];
		extArray=[NSArray arrayWithObjects:extStr,nil];
		[savePanel setAllowedFileTypes:extArray];
		[savePanel setAllowsOtherFileTypes:NO];
	}



	char iniPath[260],iniFile[260];
	if(defFn!=NULL && defFn[0]!=0)
	{
		YsSeparatePathFile(iniPath,iniFile,defFn);
		if(strcmp(iniPath,"./")==0)
		{
			getcwd(iniPath,259);
		}
	}
	else
	{
		getcwd(iniPath,259);
		iniFile[0]=0;
	}

	[savePanel setDirectory:[NSString stringWithUTF8String:iniPath]];
	// setDirectory will be replaced with setDirectoryURL
	if(iniFile[0]!=0)
	{
	  // [savePanel setNameFieldStringValue:[NSString stringWithUTF8String:iniFile]];
	}

	if(NSFileHandlingPanelOKButton==[savePanel runModal])
	{
		strcpy(fn,[[[savePanel URL] path] UTF8String]);
		// Tried: absoluteString
		printf("[Selected]\n");
		printf("%s\n",fn);

		[[NSApp mainWindow] makeKeyAndOrderFront:nil];
	
		[pool release];
		return 1;
	}

	[[NSApp mainWindow] makeKeyAndOrderFront:nil];
	fn[0]=0;
	[pool release];
	return 0;


//	FsGuiFileDialog fdlg;
//
//	if(defExt!=NULL)
//	{
//		if(defExt[0]=='*')
//		{
//			defExt++;
//		}
//		if(defExt[0]=='.')
//		{
//			defExt++;
//		}
//	}
//	else
//	{
//		defExt="*";
//	}
//
//	char iniPath[260],iniFile[260];
//	if(defFn!=NULL && defFn[0]!=0)
//	{
//		YsSeparatePathFile(iniPath,iniFile,defFn);
//		if(strcmp(iniPath,"./")==0 || strcmp(iniPath,".")==0)
//		  {
//		    getcwd(iniPath,259);
//		  }
//	}
//	else
//	{
//	  getcwd(iniPath,259); // strcpy(iniPath,".");
//		strcpy(iniFile,"*.");
//		strcat(iniFile,defExt);
//	}
//
//	YsString ful,pth,fil;
//	if(fdlg.SelectFile(ful,pth,fil,iniPath,iniFile,defExt,YSFALSE)==YSOK)
//	{
//		ful.ReplaceExtension(defExt);
//		strcpy(fn,ful);
//		return YSOK;
//	}
//	return YSERR;
}
