#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>
#include <string.h>
#include <windows.h>

#include <ysclass.h>
#include <direct.h>

#include <fssimplewindow.h>
#include <windows/fssimplewindowinternal.h>


static void BarToZero(char str[])
{
	int i,ln;
	ln=strlen(str);
	for(i=0; i<ln; i++)
	{
		if(str[i]=='|')
		{
			str[i]=0;
		}
	}
}

static void DecomposeExtList(char const *extLst[],int maxNumExt,char extbuf[])
{
	int numExt=0;
	int i=0;

	while(0!=extbuf[i] && numExt<maxNumExt-1)
	{
		if('|'!=extbuf[i])
		{
			extLst[numExt++]=extbuf+i;
			while(0!=extbuf[i])
			{
				if(extbuf[i]=='|')
				{
					break;
				}
				i++;
			}
			if(0==extbuf[i])
			{
				break;
			}
		}
		i++;
	}

	for(i=0; 0!=extbuf[i]; i++)
	{
		if(extbuf[i]=='|')
		{
			extbuf[i]=0;
		}
	}

	extLst[numExt]=NULL;
}

static void FormatExtension(char firstext[],char extformat[],char const *extlst[])
{
	if(extlst[0]==NULL || extlst==NULL)
	{
		strcpy(extformat,"(*.*)|*.*||");
		strcpy(firstext,"*.*");
		BarToZero(extformat);
	}
	else
	{
		int i,m;
		extformat[0]=0;

		for(m=0; m<2; m++)
		{
			for(i=0; extlst[i]!=NULL; i++)
			{
				char buf[256],*ext;
				strcpy(buf,extlst[i]);

				ext=buf;
				ext=(ext[0]=='*' ? ext+1 : ext);
				ext=(ext[0]=='.' ? ext+1 : ext);

				if(i!=0)
				{
					strcat(extformat,";");
				}
				strcat(extformat,"*.");
				strcat(extformat,ext);
			}
			strcat(extformat,"|");
		}

		for(i=0; extlst[i]!=NULL; i++)
		{
			char buf[256],*ext;
			strcpy(buf,extlst[i]);

			ext=buf;
			ext=(ext[0]=='*' ? ext+1 : ext);
			ext=(ext[0]=='.' ? ext+1 : ext);

			strcat(extformat,"*.");
			strcat(extformat,ext);
			strcat(extformat,"|*.");
			strcat(extformat,ext);
			strcat(extformat,"|");

			if(i==0)
			{
				sprintf(firstext,"*.%s",ext);
			}
		}
		strcat(extformat,"|");
		BarToZero(extformat);
	}
}

YSRESULT FsGuiOpenFileDialog(YsString &fn,const char title[],const char defFn[],const char defExt[],class FsGuiCanvas *theApp)
{
	int result;
	OPENFILENAME para;
	char coffee[MAX_PATH],extformat[MAX_PATH],firstext[MAX_PATH],extbuf[1024];
	char curpath[MAX_PATH],pth[MAX_PATH],fil[MAX_PATH];
	HINSTANCE module;
	char const *extLst[32];

	const FsSimpleWindowInternal *internal=FsGetSimpleWindowInternal();

	module=GetModuleHandle(NULL);

	strcpy(extbuf,defExt);
	DecomposeExtList(extLst,32,extbuf);
	FormatExtension(firstext,extformat,extLst);

	para.lStructSize=sizeof(OPENFILENAME);
	para.hwndOwner=internal->hWnd;
	para.hInstance=module;
	para.lpstrFilter=extformat;
	para.lpstrCustomFilter=NULL;
	para.nFilterIndex=0;

	_getcwd(curpath,MAX_PATH);
	if(defFn!=NULL && defFn[0]!=0)
	{
		if(YsSeparatePathFile(pth,fil,defFn)==YSOK)
		{
			strcpy(coffee,fil);

			int l;
			l=strlen(pth);
			if(pth[l-1]=='\\' || pth[l-1]=='/')
			{
				pth[l]='.';
				pth[l+1]=0;
			}

			para.lpstrFile=coffee;
			if(pth[0]!=0)
			{
				para.lpstrInitialDir=pth;
			}
			else
			{
				para.lpstrInitialDir=curpath;
			}
		}
		else
		{
			strcpy(coffee,defFn);
			para.lpstrFile=coffee;
			para.lpstrInitialDir=curpath;
		}
	}
	else
	{
		coffee[0]=0;
		para.lpstrFile=coffee;
		para.lpstrInitialDir=curpath;
	}

	int i;
	for(i=0; para.lpstrInitialDir[i]!=0; i++)
	{
		if(para.lpstrInitialDir[i]=='/')
		{
			((char *)para.lpstrInitialDir)[i]='\\';
		}
	}

	YsPrintf("Def Path=%s\n",para.lpstrInitialDir);
	YsPrintf("Def File=%s\n",para.lpstrFile);

	para.nMaxFile=sizeof(coffee);
	para.lpstrFileTitle=NULL;
	para.lpstrTitle=(title!=NULL ? title : "Open");
	para.Flags=0;
	para.lpstrDefExt=firstext+2;

	result=GetOpenFileName(&para);
	_chdir(curpath);

	if(result!=0)
	{
		fn.Set(coffee);
		return YSOK;
	}
	else
	{
		fn.Set("");
		return YSERR;
	}
}

YSRESULT FsGuiSaveFileDialog(YsString &fn,const char title[],const char defFn[],const char defExt[],class FsGuiCanvas *theApp)
{
	OPENFILENAME para;
	char coffee[MAX_PATH],extformat[MAX_PATH],firstext[MAX_PATH],extbuf[1024];;
	char curpath[MAX_PATH],pth[MAX_PATH],fil[MAX_PATH];
	int result;
	HINSTANCE module;
	char const *extLst[32];

	const FsSimpleWindowInternal *internal=FsGetSimpleWindowInternal();

	module=GetModuleHandle(NULL);

	strcpy(extbuf,defExt);
	DecomposeExtList(extLst,32,extbuf);
	FormatExtension(firstext,extformat,extLst);

	para.lStructSize=sizeof(OPENFILENAME);
	para.hwndOwner=internal->hWnd;
	para.hInstance=module;
	para.lpstrFilter=extformat;
	para.lpstrCustomFilter=NULL;
	para.nFilterIndex=0;


	_getcwd(curpath,MAX_PATH);
	if(defFn!=NULL && defFn[0]!=0)
	{
		if(YsSeparatePathFile(pth,fil,defFn)==YSOK)
		{
			strcpy(coffee,fil);

			int l;
			l=strlen(pth);
			if(pth[l-1]=='\\' || pth[l-1]=='/')
			{
				pth[l]='.';
				pth[l+1]=0;
			}

			para.lpstrFile=coffee;
			if(pth[0]!=0)
			{
				para.lpstrInitialDir=pth;
			}
			else
			{
				para.lpstrInitialDir=curpath;
			}
		}
		else
		{
			strcpy(coffee,defFn);
			para.lpstrFile=coffee;
			para.lpstrInitialDir=curpath;
		}
	}
	else
	{
		coffee[0]=0;
		para.lpstrFile=coffee;
		para.lpstrInitialDir=curpath;
	}

	int i;
	for(i=0; para.lpstrInitialDir[i]!=0; i++)
	{
		if(para.lpstrInitialDir[i]=='/')
		{
			((char *)para.lpstrInitialDir)[i]='\\';
		}
	}

	YsPrintf("Def Path=%s\n",para.lpstrInitialDir);
	YsPrintf("Def File=%s\n",para.lpstrFile);

	para.nMaxFile=sizeof(coffee);
	para.lpstrFileTitle=NULL;
	para.lpstrTitle=(title!=NULL ? title : "Save");
	para.Flags=OFN_HIDEREADONLY/* |OFN_OVERWRITEPROMPT */;
	para.lpstrDefExt=firstext+2;

	result=GetSaveFileName(&para);
	_chdir(curpath);

	if(result!=0)
	{
		fn.Set(coffee);
		return YSOK;
	}
	else
	{
		fn.Set("");
		return YSERR;
	}
}

