#include <windows.h>

#include "yswin32bitmap.h"




HBITMAP YsCreateWin32BitmapFromYsBitmap(HDC bmpDc,const YsBitmap &ysBmp)  // HDC bmpDc must be created by CreateCompatibleDC
{
	int bmpWid,bmpHei;
	HBITMAP bmp;
	BITMAPINFOHEADER bmiHeader;
	void *bitBuf;

	bmpWid=(ysBmp.GetWidth()+3)&(~3);
	bmpHei=ysBmp.GetHeight();

	bmiHeader.biSize=sizeof(bmiHeader);
	bmiHeader.biWidth=bmpWid;
	bmiHeader.biHeight=bmpHei;
	bmiHeader.biPlanes=1;
	bmiHeader.biBitCount=24;
	bmiHeader.biCompression=BI_RGB;
	bmiHeader.biSizeImage=0;
	bmiHeader.biXPelsPerMeter=2048;
	bmiHeader.biYPelsPerMeter=2048;
	bmiHeader.biClrUsed=0;
	bmiHeader.biClrImportant=0;

	bmp=CreateDIBSection
	    (bmpDc,(BITMAPINFO *)&bmiHeader,DIB_RGB_COLORS,&bitBuf,NULL,0);

	int x,y;
	unsigned char *buf;
	buf=(unsigned char *)bitBuf;
	for(y=0; y<bmpHei; y++)
	{
		for(x=0; x<bmpWid; x++)
		{
			const unsigned char *rgba;
			if(x<ysBmp.GetWidth())
			{
				rgba=ysBmp.GetRGBAPixelPointer(x,y);
			}
			else
			{
				rgba=ysBmp.GetRGBAPixelPointer(ysBmp.GetWidth()-1,y);
			}
			buf[(y*bmpWid+x)*3  ]=rgba[2];
			buf[(y*bmpWid+x)*3+1]=rgba[1];
			buf[(y*bmpWid+x)*3+2]=rgba[0];
		}
	}

	return bmp;
}

