#ifndef YSNEVERFORGET_IS_INCLUDED
#define YSNEVERFORGET_IS_INCLUDED
/* { */

template <class T>
class YsObjectFromHeap
{
private:
	T *objPtr;
public:
	inline YsObjectFromHeap();
	inline ~YsObjectFromHeap();
	inline operator T &();
	inline operator const T &() const;

	inline T &Get();
	inline const T &Get() const;
};

template <class T>
inline YsObjectFromHeap <T>::YsObjectFromHeap()
{
	objPtr=new T;
}


template <class T>
inline YsObjectFromHeap <T>::~YsObjectFromHeap()
{
	delete objPtr;
}

template <class T>
inline YsObjectFromHeap <T>::operator T &()
{
	return *objPtr;
}

template <class T>
inline YsObjectFromHeap <T>::operator const T &() const
{
	return *objPtr;
}

template <class T>
inline T &YsObjectFromHeap <T>::Get()
{
	return *objPtr;
}

template <class T>
inline const T &YsObjectFromHeap <T>::Get() const
{
	return *objPtr;
}

/* } */
#endif
