#ifndef YSPRINTF_IS_INCLUDED
#define YSPRINTF_IS_INCLUDED
/* { */

#include "ysdef.h"

#ifndef __GNUC__
#define __attribute__(x)
#endif

// Declaration /////////////////////////////////////////////
class YsPrintf
{
protected:
	virtual void Output(char str[]);
public:
	YsPrintf();
	YsPrintf(const char *fom,...) __attribute__ ((format (printf,2,3)));
	YsPrintf(int a,const char *fom,...) __attribute__ ((format (printf,3,4)));

	static YsPrintf *def;
	static YSBOOL masterSwitch;
	YSBOOL enabled;

	int Printf(const char *fom,...) __attribute__ ((format (printf,2,3)));

	void SetDefault(void);
	void ResetDefault(void);

	static YsPrintf *GetDefault(void);
};

////////////////////////////////////////////////////////////

void YsTurnOnErrorOutput(void);
void YsTurnOffErrorOutput(void);
int YsErrOut(const char *fmt,...) __attribute__ ((format (printf,1,2)));

void YsTurnOnDiagnosticOutput(void);
void YsTurnOffDiagnosticOutput(void);
int YsDiagOut(const char *fmt,...) __attribute__ ((format (printf,1,2)));

////////////////////////////////////////////////////////////

class YsLoopCounter
{
public:
	YsLoopCounter();
	void BeginCounter(YSSIZE_T length);
	void ShowCounter(YSSIZE_T ctr);
	void Increment(void);
	void EndCounter(void);

	void SetOutput(YsPrintf *print);

	YSSIZE_T GetCount(void) const;

	static unsigned int defUpdateInterval;
	static char defNewLine;

protected:
	unsigned lastShowedTime;
	unsigned updateInterval;
	YSSIZE_T length;
	YSSIZE_T current;
	YsPrintf *output;
};

/* } */
#endif
