#ifndef YSTEXTRESOURCE_IS_INCLUDED
#define YSTEXTRESOURCE_IS_INCLUDED
/* { */

#include "ysstring.h"
#include "ysproperty.h"
#include "ysbinarytree.h"

class YsTextResource
{
private:
	YsString label;
	YsColor fgCol,bgCol;

	class YsTextResourceBinaryTree *tree;
	// I want to write YsStringBinaryTree directly here, but if I do so,
	// Visual C++ 2008 gives a warning that totally doesn't make sense:
	//     ysbinarytree.h(371) : warning C4505: 'YsStringBinaryTree<KEYTYPE,ASSOCTYPE>::Compare' : 
	//     unreferenced local function has been removed
	// Compare is a template function and if it is not used, it is deleted.  Period.
	// I say Visual Studio 2008 is wrongfully accusing this function.
public:
	YsTextResource();
	virtual ~YsTextResource();
	void Initialize(void);

	YSRESULT LoadFile(const char fn[]);
	YSRESULT LoadFile(FILE *fp);
protected:
	YSRESULT SendCommand(const YsString &cmd);
	YSRESULT SendDollarCommand(const YsString &cmd);
	YSRESULT SendDictCommand(const YsString &cmd);

public:
	const wchar_t *FindWString(const char key[]);
};

/* } */
#endif
