#ifndef YSGLDEF_IS_INCLUDED
#define YSGLDEF_IS_INCLUDED
/* { */

/* Force Visual C++ to type-mismatching error. */
#pragma warning( error : 4028)
#pragma warning( error : 4047)

#ifndef YSRESULT_IS_DEFINED
#define YSRESULT_IS_DEFINED
/*! Enum for processing result. */
typedef enum
{
	YSERR,  /*!< There were error(s). */
	YSOK    /*!< The process was successful. */
} YSRESULT;
#endif

#ifndef YSBOOL_IS_DEFINED
#define YSBOOL_IS_DEFINED
/*! Enum for boolearn. */
typedef enum
{
	YSFALSE,     /*!< False */
	YSTRUE,      /*!< True */
	YSTFUNKNOWN  /*!< Unable to tell true or false. */
} YSBOOL;
#endif


enum YSGLSL_HALIGN
{
	YSGLSL_HALIGN_LEFT,
	YSGLSL_HALIGN_CENTER,
	YSGLSL_HALIGN_RIGHT
};

enum YSGLSL_VALIGN
{
	YSGLSL_VALIGN_TOP,
	YSGLSL_VALIGN_CENTER,
	YSGLSL_VALIGN_BOTTOM
};

enum YSGLSL_VIEWPORT_ORIGIN {
	YSGLSL_TOPLEFT_AS_ORIGIN,
	YSGLSL_BOTTOMLEFT_AS_ORIGIN
};


#define YSGLSL_TEX_TYPE_NONE           0
#define YSGLSL_TEX_TYPE_NONE_STR      "0"
#define YSGLSL_TEX_TYPE_TILING         1
#define YSGLSL_TEX_TYPE_TILING_STR    "1"
#define YSGLSL_TEX_TYPE_BILLBOARD      2
#define YSGLSL_TEX_TYPE_BILLBOARD_STR "2"
#define YSGLSL_TEX_TYPE_3DTILING       3
#define YSGLSL_TEX_TYPE_3DTILING_STR  "3"

#define YSGLSL_TEX_BILLBOARD_PERS       0
#define YSGLSL_TEX_BILLBOARD_PERS_STR  "0"
#define YSGLSL_TEX_BILLBOARD_ORTHO      1
#define YSGLSL_TEX_BILLBOARD_ORTHO_STR "1"

#define YSGLSL_TEX_WRAP_CUTOFF       0
#define YSGLSL_TEX_WRAP_CUTOFF_STR  "0"
#define YSGLSL_TEX_WRAP_REPEAT       1
#define YSGLSL_TEX_WRAP_REPEAT_STR  "1"

#define YSGLSL_BILLBOARD_CLIPPING_NONE                      0
#define YSGLSL_BILLBOARD_CLIPPING_NONE_STR                 "0"
#define YSGLSL_BILLBOARD_CLIPPING_CIRCLE                    1
#define YSGLSL_BILLBOARD_CLIPPING_CIRCLE_STR               "1"

/* } */
#endif
